
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>从实例看hibernate的主键生成策略 / 憋错料</title>

    <meta name="description" content="从实例看hibernate的主键生成策略 学习了hibernate会发现,hibernate中有实体类,实体类的映射文件,但是我们怎么样才能知道实体类的主键是怎样的生成方式呢?hibernate提供的主键生成策略帮我们完美地解答了这个疑问.下面让我们一起从实例开始认识hibernate的实体生成策略. 一.首先通过User实体类和映射文件的实例 ?User的实体类 package com.bjpowernode.hibernate; import java.util.Set; public class User { private in">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">从实例看hibernate的主键生成策略</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>学习了hibernate会发现，hibernate中有实体类，实体类的映射文件，但是我们怎么样才能知道实体类的主键是怎样的生成方式呢?hibernate提供的主键生成策略帮我们完美地解答了这个疑问。下面让我们一起从实例开始认识hibernate的实体生成策略。</p>
<h2>一、首先通过User实体类和映射文件的实例</h2>
<p><strong>?</strong>User的实体类</p>
<pre>package com.bjpowernode.hibernate;

import java.util.Set;

public class User {

	private int id;

	private String name;

	private Set roles;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Set getRoles() {
		return roles;
	}

	public void setRoles(Set roles) {
		this.roles = roles;
	}
}</pre>
<p><strong>?</strong>映射文件：User.hbm.xml</p>
<pre>&lt;?xml version=&quot;1.0&quot;?&gt;
&lt;!DOCTYPE hibernate-mapping PUBLIC
	&quot;-//Hibernate/Hibernate Mapping DTD 3.0//EN&quot;
	&quot;http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd&quot;&gt;
&lt;hibernate-mapping&gt;
	&lt;class name=&quot;com.bjpowernode.hibernate.User&quot; table=&quot;t_user&quot;&gt;
		&lt;id name=&quot;id&quot;&gt;   /*表示id是主键，且使用的策略是native*/
			&lt;generator class=&quot;native&quot;/&gt;
		&lt;/id&gt;
		&lt;property name=&quot;name&quot;/&gt;
		&lt;set name=&quot;roles&quot; table=&quot;t_user_role&quot;&gt;
			&lt;key column=&quot;user_id&quot; not-null=&quot;true&quot;/&gt;
			&lt;many-to-many class=&quot;com.bjpowernode.hibernate.Role&quot; column=&quot;role_id&quot; /&gt;
		&lt;/set&gt;
	&lt;/class&gt;
&lt;/hibernate-mapping&gt;</pre>
<h2>二、hibernate主键生成策略解析</h2>
<p>对于主键生成策略，针对我的理解，主要将它分为自增长型、保证唯一性型、手动型、依赖数据库型四类。</p>
<h3>1.自增长型：</h3>
<p>（1）increment</p>
<p>a)对主键&#20540;采取自动顺序增长的方式生成新的主键，&#20540;默认从1开始。</p>
<p>b)原理:在当前应用实例中维持一个变量,以保存当前最大&#20540;,之后每次需要生成主键&#20540;的时候将此&#20540;加1作为主键.不依赖于底层的数据库，因此所有的数据库都可以使用</p>
<p>c)缺点:通过increment的生成主键的原理可推断，此种主键生成策略不适用于集群、同一时段大量用户并发访问的系统，既当大量用户同一时间段同时进行插入操作的时候，可能存在取得相同的最大&#20540;然后再同时&#043;1的情况,这个时候就会造成主键冲突。因此，如果同一数据库有多个实例访问，此方式必须避免使用。</p>
<p>（2）identity</p>
<p>a)根据底层数据库，来支持自动增长，不同的数据库用不同的主键增长方式。</p>
<p>b)特点:<br />
 与底层数据库有关，要求数据库支持Identity，如MySQl中是auto_increment, SQL Server 中是Identity。支持的数据库有MySql、SQL Server、DB2、Sybase和HypersonicSQL。</p>
<p>c)好处:在建表的时候指定了id为自动增长,实际开发中就不需要自己定义插入数据库的主键&#20540;,系统会自动顺序递增一个&#20540;<br />
 。Identity无需Hibernate和用户的干涉，使用较为方便，但由于依赖于数据库，所以不便于在不同的数据库之间移植程序。</p>
<h3>2.保证“唯一性”型</h3>
<p>（1）UUID</p>
<p>a)原理UUID使用128位UUID算法生成主键，能够保证网络环境下的主键唯一性，也就能够保证在不同数据库及不同服务器下主键的唯一性。所以使用于所有数据库。</p>
<p>b)特点;能够保证数据库中的主键唯一性，但是在生成的主键占用比较多的存贮空间</p>
<p>（2）Hilo　</p>
<p>a)原理:通过hi/lo<br />
 算法(Hilo使用高低位算法生成主键，高低位算法使用一个高位&#20540;和一个低位&#20540;，然后把算法得到的两个&#20540;拼接起来)实现的主键生成机制，需要额外的数据库表保存主键生成历史状态。</p>
<p>b)特点：需要额外的数据库表和字段提供高位&#20540;来源。默认情况下使用的表是<br />
 hibernate_unique_key，默认字段叫作next_hi。next_hi必须有一条记录否则会出现错误。需要额外的数据库表的支持，能保证同一个数据库中主键的唯一性，但不能保证多个数据库之间主键的唯一性。Hilo主键生成方式由Hibernate<br />
 维护，所以Hilo方式与底层数据库无关。</p>
<h3>3.依赖数据库型：</h3>
<p>【PS：UUID，increment、Hilo、assigned：对数据库无依赖】</p>
<p>（1）sequence<strong>&nbsp;</strong></p>
<p>sequence实际是就是一张单行单列的表。</p>
<p>（2）native</p>
<p>a)作用:根据数据库的类型,自动在sequence<br />
 、identity和,hilo进行切换。</p>
<p>b)实现自动切换的依据:根据Hibernate配置文件中的方言来判断是Oracle还是Mysql、SqlServer,然后针对数据库的类型抉择<br />
 sequence还是identity作为主键生成策略。</p>
<p>c)用处：由于Hibernate会根据底层数据库采用不同的映射方式，因此灵活性高，便于程序移植，项目中如果用到多个数据库时，可以使用这种方式。</p>
<p>（3）foreign<strong>&nbsp;</strong></p>
<p>只适用基于共享主键的一对一关联映射的时候使用。即一个对象的主键是参照的另一张表的主键生成的。</p>
<h3>4.手动型（唯一一个）</h3>
<p>（1）assigned</p>
<p>a)作用:用于手工分配主键生成器,一旦指定为这个了,Hibernate就不在自动为程序做主键生成器了。没有指定&lt;generator&gt;标签时，默认就是assigned主键的生成方式</p>
<p>b)使用方法:在程序中session.save();之前,由程序员自己指定主键&#20540;为多少。例如:user.setId(1);这就是在程序中程序员手动为用户表指定主键&#20540;为1。</p>
<h1>三、总结：</h1>
<p>一般来说推荐UUID，因为生成主键唯一，且对数据库无依赖，可移植性强。由于常用的数据库，如Oracle、DB2、SQLServer、MySql<br />
 等，都提供了易用的主键生成机制（Auto-Increase 字段或者Sequence）。我们可以在数据库提供的主键生成机制上，采用native，sequence或者identity的主键生成方式。</p>
<p>不过&#20540;得注意的是，一些数据库提供的主键生成机制在效率上未必最佳大量并发insert数据时可能会引起表之间的互锁。因此，对于并发Insert要求较高的系统，推荐采用uuid作为主键生成机制。</p>
<p>总之，hibernate主键生成器选择，还要具体情况具体分析**。一般而言，利用uuid方式生成主键将提供最好的性能和数据库平台适应性。</p>
<p>版权声明：本文为博主原创文章，未经博主允许不得转载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 09:52:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%a1%86%e6%9e%b6/" title="框架">框架</a>, <a href="https://www.biecuoliao.com/tag/hibernate/" title="hibernate">hibernate</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>从实例看hibernate的主键生成策略的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47X8v9M.html" rel="bookmark">hibernate annotation 主键生成策略的相关配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hibernate 默认总共支持 13 种生成策略 : 1. increment 2.  identity 3. sequence 4. hilo 5. seqhilo 6. uuid 7. uuid.hex 8. guid 9. native 10. assigned 11. select 12. foreign 13. sequence-identity 下面介绍几个较为常用的策略 : ① identity [ 自然递增 ] 支持 DB2,MySQL,SQL Server,Sybase 和H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEWYAg3.html" rel="bookmark">hibernate id主键生成策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据库的设计和操作中,我们通常会给表建立主键. 主键,可以分为自然主键和代理主键. 自然主键表示:采用具有业务逻辑含义的字段作为表的主键.比如在用户信息表中,采用用户的身份证号码作为主键.但是这样一来,随着业务逻辑的变化,主键就有可能要更改.比如,假设哪天身份证号码升级成19,2位,那....... 代理主键:在表中人为的增加一个字段,该字段并没有表示任何的业务逻辑,仅仅用来标识一行数据.比如说在用户信息表中,增加一个用户ID的字段.用来表示该条用户信息的记录. 通常情况下,用的比较多的是代理主			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGEPZa3.html" rel="bookmark">Hibernate常用主键生成策略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.assign:适合于应用程序维护的自然主键. 2.increment:代理主键,适合于所有数据库,由hibernate维护主键自增,和底层数据库无关,但是不适合于2个或以上hibernate进程. 3.identity:代理主键,适合于mysql或ms sql server等支持自增的dbms,主键值不由hibernate维护. 4.sequence:代理主键,适合于oracle等支持序列的dbms,主键值不由hibernate维护,由序列产生. 5.native:代理主键,根据底层数据库的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0R8j8P4.html" rel="bookmark">Hibernate各种主键生成策略与配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.assigned 主键由外部程序负责生成,在 save() 之前必须指定一个.Hibernate不负责维护主键生成.与Hibernate和底层数据库都无关,可以跨数据库.在存储对象前,必须要使用主键的setter方法给主键赋值,至于这个值怎么生成,完全由自己决定,这种方法应该尽量避免. &lt;id name=&quot;id&quot; column=&quot;id&quot;&gt; &lt;generator class=&quot;assigned&quot; /&gt; &lt;/id&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVwbWy0.html" rel="bookmark">大家一起撸代码之&mdash;&mdash;Hibernate各种主键生成策略与配置详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.assigned 主键由外部程序负责生成,在 save() 之前必须指定一个.Hibernate不负责维护主键生成.与Hibernate和底层数据库都无关,可以跨数据库.在存储对象前,必须要使用主键的setter方法给主键赋值,至于这个值怎么生成,完全由自己决定,这种方法应该尽量避免. &lt;id name=&quot;id&quot; column=&quot;id&quot;&gt; &lt;generator class=&quot;assigned&quot; /&gt; &lt;/id&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Nqroy3.html" rel="bookmark">Hibernate各种主键生成策略与配置详解【附1--&amp;lt&semi;generator class&equals;&amp;quot&semi;foreign&amp;quot&semi;&amp;gt&semi;】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.assigned 主键由外部程序负责生成,在 save() 之前必须指定一个.Hibernate不负责维护主键生成.与Hibernate和底层数据库都无关,可以跨数据库.在存储对象前,必须要使用主键的setter方法给主键赋值,至于这个值怎么生成,完全由自己决定,这种方法应该尽量避免. &lt;id name=&quot;id&quot; column=&quot;id&quot;&gt; &lt;generator class=&quot;assigned&quot; /&gt; &lt;/id&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MymWbYM.html" rel="bookmark">Hibernate 之主键生成策略小总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主键生成策略大致分两种: 手工控制策略 自动生成策略[框架自动生成和数据库自动生成] 手工控制策略: assigned:类型是任意的,需要在 save() 到数据库前,编码人员手工设置主键值,也就是调用对象的 setter方法进行赋值操作. 注:可以跨数据库,但是手动控制不能保证不重复,不推荐使用. 自动生成策略: 1 . uuid:自动生成 32 位及以上的随机字符串,生成的依据包括但不限于网卡地址,时间值等. 注:可以跨数据库,效率高,能保证唯一性,推荐使用[虽然占用空间大] 2 . inc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41exqY4.html" rel="bookmark">Hibernate各种主键生成策略与配置详解&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接:http://www.cnblogs.com/hoobey/p/5508992.html 1.assigned 主键由外部程序负责生成,在 save() 之前必须指定一个.Hibernate不负责维护主键生成.与Hibernate和底层数据库都无关,可以跨数据库.在存储对象前,必须要使用主键的setter方法给主键赋值,至于这个值怎么生成,完全由自己决定,这种方法应该尽量避免. &lt;id name=&quot;id&quot; column=&quot;id&quot;&gt; &lt;ge			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6n6A5M.html" rel="bookmark">Hibernate各种主键生成策略与配置详解《转》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.assigned 主键由外部程序负责生成,在 save() 之前必须指定一个.Hibernate不负责维护主键生成.与Hibernate和底层数据库都无关,可以跨数据库.在存储对象前,必须要使用主键的setter方法给主键赋值,至于这个值怎么生成,完全由自己决定,这种方法应该尽量避免. &lt;id name=&quot;id&quot; column=&quot;id&quot;&gt; &lt;generator class=&quot;assigned&quot; /&gt; &lt;/id&g			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXzG3J.html" rel="bookmark" class="title">利用 Django REST framework 编写 RESTful API</a>
					<div>
						利用 Django REST framework 编写 RESTful API Updateat 2015/12/3: 增加 filter 最近在玩 Django,不得不说 rest_framewor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYqNP3.html" rel="bookmark" class="title">iOS10 权限崩溃问题-b</a>
					<div>
						手机升级了 iOS10 Beta,然后用正在开发的项目 装了个ipa包,发现点击有关 权限访问 直接Crash了,并在控制台输出了一些信息: This app has crashed because  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdWdkM.html" rel="bookmark" class="title">将cell转化为全屏横屏显示</a>
					<div>
						- (void)fullButtonAction:(UIButton *)sender{ UIWindow *keyWindow = [UIApplication sharedApplication] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388NPg3.html" rel="bookmark" class="title">Redmine管理项目2-邮件通知</a>
					<div>
						下面是为Redmine配置邮件通知 配置文件 config/configuration.yml 是 Redminde 的配置文件,里面有非常多的选项,邮件通知.附件保存地址. SCM .rmagick ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjXzY0.html" rel="bookmark" class="title">unity 实现物体破碎效果的一些方法</a>
					<div>
						游戏越来越接近现实的感觉,如果有一个真是的 虚拟现实设备,可能我们真的会感觉是在真实世界.场景的逼真是在渲染效果.角色AI.游戏逻辑.物理效果等等一起导致的结果.现在游戏越来越大,除了渲染,物理估计是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qpXK3.html" rel="bookmark" class="title">POJ-3268 Silver Cow Party&lpar; 最短路 &rpar;</a>
					<div>
						题目链接:http://poj.org/problem?id=3268 Description One cow from each of N farms (1 ≤ N ≤ 1000) convenie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWDzLa0.html" rel="bookmark" class="title">&lbrack;hdu5247&rsqb;rmq&plus;预处理</a>
					<div>
						题意:有一个无序数组,求有多少个长度为k的区间满足把区间内的数排序后是连续的. 思路:长度为k的区间排序后是 连续的数等价于maxval-minval等于k-1并且不同的数有k个(或者说没有相同的数) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElzAx4.html" rel="bookmark" class="title">每天读一遍，不久你就会变！</a>
					<div>
						1.别低估任何人.2.你没那么多观众,别那么累.3.温和对人对事.不要随意发脾气,谁都不欠你的.4.现在很痛苦,等过阵子回头看看,会发现其实那都不算事.5.和对自己有恶意的人绝交.人有绝交,才有至交. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lN7gP4.html" rel="bookmark" class="title">&lbrack;mysql&lpar;0&rpar;&rsqb; 64位Linux下安装mysql-5&period;7&period;13-linux-glibc2&period;5-x86&lowbar;64</a>
					<div>
						由于公司临时让将Oracle的数据移植到mysql上面,所以让我在公司服务器上面安装一下mysql.下面就是我的安装过程以及一些错误解决思路.其实对于不同版本安装大体都有差不多. 1. 从官网下载 m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNKP10.html" rel="bookmark" class="title">ubuntu安装hexo博客</a>
					<div>
						ubuntu下安装hexo博客 一 安装git sudo apt-get install git 二 安装nodejs 官网下载linux安装包.tar.gz文件 解压 tar zxvf 这样变可以切 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1rkb3.html" rel="bookmark" class="title">boost 相关</a>
					<div>
						编译boost: 1.打开Microsoft Visual Studio 2010 -&gt; Visual Studio Tools -&gt; Visual Studio Command Prom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bKJKo3.html" rel="bookmark" class="title">ReactiveCocoa 使用3</a>
					<div>
						前言 很多blog都说ReactiveCocoa好用,然后各种秀自己如何灵活运用ReactiveCocoa,但是感觉真正缺少的是一篇如何学习ReactiveCocoa的文章,小编看了很多篇都没看出怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXL583.html" rel="bookmark" class="title">推测的手机型号和cpu模型</a>
					<div>
						&lt;span style=&quot;font-size:18px;&quot;&gt;推断手机型号:&lt;/span&gt; &lt;span style=&quot;font-size:18 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXOVPM.html" rel="bookmark" class="title">更新脚本</a>
					<div>
						#!/bin/bash # #update scripts Nowtime=$(date +%Y-%m-%d:%H:%M:%S) rmyzzt_svn=/usr/oldyzztserver portl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAolz3.html" rel="bookmark" class="title">&lbrack;php&rsqb;referer应用--http防盗链技术</a>
					<div>
						1.防盗链的理解 所谓防盗链是防止其他的网站引用自己网站的资源连接,比如图片.视频等等,但是并不会阻碍从自己网站上享受资源的用户,这就要求能够将其他网站的连接请求阻止 2.防盗链的原理 其实从自己网站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPkBy3.html" rel="bookmark" class="title">What are the 10 algorithms one must know in order to solve most algorithm challenges&sol;puzzles&quest;</a>
					<div>
						QUESTION : ANSWER: Dynamic Programming (DP) appears to account for a plurality (some estimate up to  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvVlEM.html" rel="bookmark" class="title">Linux 入门记录：六、Linux 硬件相关概念（硬盘、磁盘、磁道、柱面、磁头、扇区、分区、MBR、GPT）</a>
					<div>
						一.硬盘 硬盘的功能相当简单但很重要,它负责记录系统所需要的各种数据.硬盘记录数据有两个方面,一个是硬件方面的存储原理和结构,另外一方面则是软件方面的数据和文件系统.硬盘的主要行为就是数据的存放和取出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnoNZM.html" rel="bookmark" class="title">是否可以修改 JavaScript 的本地对象&lpar;native object&rpar;</a>
					<div>
						本文翻译自RapydScript的作者 Alexander Tsepkov 的博客. 原文地址:http://blog.pyjeon.com/2014/05/17/modifying-native-j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41nD7YM.html" rel="bookmark" class="title">Linux克隆引发的网卡启动失败多种解决方案</a>
					<div>
						故障现象: 最近在公司测试环境克隆了几个Linux系统,重启之后发现,网卡eth0都不见了 于是检查了网卡配置,最终想到以下几种解决方案,网卡启动信息如图所示: [[email protected]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX1PxX0.html" rel="bookmark" class="title">notepad&plus;&plus;崩溃后文件内容变为NUL的解决方法</a>
					<div>
						毫无疑问,notepad++是一款非常优秀的文本编辑器,但是notepad++有时候会崩溃,之后文件内容就会全部变成NUL 当你打文件看到自己辛辛苦苦的成果全都变成NUL是不是有想哭的感觉?&quot ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
